const {refObject, world} = require("@tabletop-playground/api");

refObject.homePos = null;
refObject.homeRot = null;
if (!refObject.isValid()) {
	refObject.onCreated.add(function(self){
		self.homePos = self.getPosition();
		self.homeRot = self.getRotation();
	});
} else {
	refObject.homePos = refObject.getPosition();
	refObject.homeRot = refObject.getRotation();
}

refObject.resetHandler = null;
refObject.onMovementStopped.add(function(self) {
    if (self.resetHandler !== null) {
        clearTimeout(self.resetHandler);
    }

    self.resetHandler = setTimeout(function() {
        self.setPosition(self.homePos);
        self.setRotation(self.homeRot);
        self.resetHandler = null;
    }, 10000);
});

refObject.onDestroyed.add(function(self) {
    let newSelf = world.createObjectFromTemplate(self.getTemplateId(), self.homePos);
    setTimeout(function(homePos, homeRot, color) {
        newSelf.homePos = homePos;
        newSelf.homeRot = homeRot;
        newSelf.setRotation(homeRot);
        newSelf.setPrimaryColor(color);
    }, 0, self.homePos, self.homeRot, self.getPrimaryColor());
});